#ifndef ___TinyInt
#define ___TinyInt

#include <limits>
#include <iostream>

//--- NX ---//
class TinyInt {
	int v;			// l

public:
	TinyInt(int value = 0) : v(value) { }		//--- RXgN^ ---//

	operator int() const { return v; }			//--- intւ̕ϊ֐  ---//

	bool operator!() const { return v == 0; }	//--- _ے艉Zq! ---//

	TinyInt& operator++() { 					//--- OuZq++ ---//
		if (v < std::numeric_limits<int>::max()) v++;	// l̏int̍ől
		return *this;									// gւ̎QƂԋp
	}

	TinyInt operator++(int) {				//--- uZq++ ---//
		TinyInt x = *this;						// CNgO̒lۑ
		++(*this);								// OuZqŃCNg
		return x;								// ۑĂlԋp
	}

	friend TinyInt operator+(const TinyInt& x, const TinyInt& y) {	// x + y
		return TinyInt(x.v + y.v);
	}

	//--- Zq += ---//
	TinyInt& operator+=(const TinyInt& x) { v += x.v; return *this; }

	friend bool operator==(const TinyInt& x, const TinyInt& y) { return x.v == y.v; }

	friend bool operator!=(const TinyInt& x, const TinyInt& y) { return x.v != y.v; }

	friend bool operator> (const TinyInt& x, const TinyInt& y) { return x.v >  y.v; }

	friend bool operator>=(const TinyInt& x, const TinyInt& y) { return x.v >= y.v; }

	friend bool operator< (const TinyInt& x, const TinyInt& y) { return x.v <  y.v; }

	friend bool operator<=(const TinyInt& x, const TinyInt& y) { return x.v <= y.v; }

	friend std::ostream& operator<<(std::ostream& s, const TinyInt& x) {
		return s << x.v;
	}
};

#endif
